;; This is the Manufaturing Plant Domain
;;
;; This model was generated by itSIMPLE tool.
;; The model was created using itSIMPLE tool in the context of the 
;; ICKEPS competition (ICKEPS'07). Based on the planning domain 
;; described by J. Benton and Minh B. Do and Wheeler Ruml available at 
;; http://abotea.rsise.anu.edu.au/satellite-events-icaps07/ickeps/PARC.pdf
;;
;; Authors: Tiago Stegun Vaquero and Marcelo Udo
;; Contact: tiago.vaquero@poli.usp.br
;; http://dlab.poli.usp.br


(define (domain ManufaturingPlantDomain_v1)
    (:requirements :typing :quantified-preconditions :durative-actions)
    (:types
      Machine - object
      Product - object
      Attribute - object
      MachineType - object
    )
    (:constants
       ismachine - MachineType
       isoutput - MachineType
    )
    (:predicates
      (produces ?mac - Machine ?att - Attribute)
      (connected ?mac - Machine ?mac1 - Machine)
      (hasAttribute ?pro - Product ?att - Attribute)
      (at ?pro - Product ?mac - Machine)
      (ready ?mac - Machine)
      (sort ?mac - Machine ?mac1 - MachineType)
    )
    (:durative-action add-attribute
     :parameters (?m1 - Machine ?p1 - Product ?at1 - Attribute)
     :duration (= ?duration 2)
     :condition 
       (at start 
         (and
           (at ?p1 ?m1)
           (produces ?m1 ?at1)
         )
       )

     :effect
       (at end  (hasAttribute ?p1 ?at1))
    )

    (:durative-action transport
     :parameters (?m1 - Machine ?p1 - Product ?m2 - Machine)
     :duration (= ?duration 10)
     :condition 
       (at start 
         (and
           (at ?p1 ?m1)
           (connected ?m1 ?m2)
           (sort ?m2 ismachine)
           (ready ?m2)
         )
       )

     :effect
       (at end 
         (and
           (at ?p1 ?m2)
           (ready ?m1)
           (not (ready ?m2))
           (not (at ?p1 ?m1))
         )
       )

    )

    (:durative-action transport-out
     :parameters (?m1 - Machine ?p1 - Product ?m2 - Machine)
     :duration (= ?duration 10)
     :condition 
       (at start 
         (and
           (at ?p1 ?m1)
           (connected ?m1 ?m2)
           (sort ?m2 isoutput)
         )
       )

     :effect
       (at end 
         (and
           (at ?p1 ?m2)
           (ready ?m1)
           (not (at ?p1 ?m1))
         )
       )

    )

)
