(define (domain Solitaire_v1)
    (:requirements :typing :negative-preconditions :quantified-preconditions)
    (:types
      Hole - object
      Player - object
    )
    (:predicates
      (right ?hol - Hole ?hol1 - Hole)
      (down ?hol - Hole ?hol1 - Hole)
      (empty ?hol - Hole)
    )
    (:action moveUp
     :parameters (?p - Player ?h1 - Hole ?h2 - Hole ?h3 - Hole)
     :precondition 
       (and
         (down ?h1 ?h2)
         (down ?h2 ?h3)
         (empty ?h1)
         (not (empty ?h2))
         (not (empty ?h3))
       )
     :effect
       (and
         (not (empty ?h1))
         (empty ?h2)
         (empty ?h3)
       )
    )

    (:action moveDown
     :parameters (?p - Player ?h1 - Hole ?h2 - Hole ?h3 - Hole)
     :precondition 
       (and
         (down ?h1 ?h2)
         (down ?h2 ?h3)
         (not (empty ?h1))
         (not (empty ?h2))
         (empty ?h3)
       )
     :effect
       (and
         (empty ?h1)
         (empty ?h2)
         (not (empty ?h3))
       )
    )

    (:action moveRight
     :parameters (?p - Player ?h1 - Hole ?h2 - Hole ?h3 - Hole)
     :precondition 
       (and
         (right ?h1 ?h2)
         (right ?h2 ?h3)
         (not (empty ?h1))
         (not (empty ?h2))
         (empty ?h3)
       )
     :effect
       (and
         (empty ?h1)
         (empty ?h2)
         (not (empty ?h3))
       )
    )

    (:action moveLeft
     :parameters (?p - Player ?h1 - Hole ?h2 - Hole ?h3 - Hole)
     :precondition 
       (and
         (right ?h1 ?h2)
         (right ?h2 ?h3)
         (empty ?h1)
         (not (empty ?h2))
         (not (empty ?h3))
       )
     :effect
       (and
         (not (empty ?h1))
         (empty ?h2)
         (empty ?h3)
       )
    )

)
