(define (domain Petri_Nets_v1)
    (:requirements :typing :fluents :quantified-preconditions :conditional-effects)
    (:types
      Place - object
      Transition - object
    )
    (:predicates
      (outgoing ?tra - Transition ?pla - Place)
      (incoming ?tra - Transition ?pla - Place)
    )
    (:functions
      (numberOfTokens ?pla - Place)
    )
    (:action fire
     :parameters (?t - Transition)
     :precondition 
       (forall (?p - Place)
         (imply
           (incoming ?t ?p)
           (> (numberOfTokens ?p) 0)
         )
       )
     :effect
       (and
         (forall (?p - Place)
           (when
             (incoming ?t ?p)
             (decrease (numberOfTokens ?p) 1)
           )
         )
         (forall (?p - Place)
           (when
             (outgoing ?t ?p)
             (increase (numberOfTokens ?p) 1)
           )
         )
       )
    )

)
